const fs = require("fs");

const asdf = require("asdf-games");
// eslint-disable-next-line no-unused-vars
const { Container, Texture, TileMap } = asdf;

const texture = new Texture("../res/images/terrainTiles_default.png");
const tilemap = JSON.parse(fs.readFileSync("./res/images/terrainTiles_default.json"));

const Object = require("../entities/Object.js");

class Level extends TileMap {
  constructor(level, game, players) {
    var tileData = [];
    level.tileData.forEach(value => {
      tileData.push(tilemap[value]);
    });

    super(tileData, Math.ceil(game.w / 64), Math.ceil(game.h / 64), 64, 64, texture);
    this.game = game;
    this.players = players;
        
    this.bullets = new Container();
    this.children.push(this.bullets);

    this.objects = new Container();
    level.objects.forEach(element => {
      this.objects.add(
        new Object(this, element.pos, element.properties)
      );
    });

    this.children.push(this.objects);
  }

  update(dt, t) {
    super.update(dt, t);
  }
}

module.exports = Level;