const { Container, Texture, Sprite, Rect } = require("asdf-games");

class LogoScreen extends Container {
  constructor(onDone) {
    super();
    this.onDone = onDone;
    // Timer variable
    this.period = 0;
    // Alpha control variable
    this.alpha = 1;

    // Asdf logo in the center of the screen.
    const logo = new Sprite(new Texture(__dirname + "/../../res/asdf-logo.png"));
    logo.pos = { x: (740 - 412) / 2, y: (480 - 140) / 2 };
    this.add(logo);

    // Overlay to control the fade
    const overlay = new Rect(740, 480, { fill: "rgba(0,0,0,1)" });
    this.add(overlay);
  }

  update(dt) {
    // Update the overlay's alpha.
    this.children[1].style.fill = `rgba(0,0,0,${this.alpha})`;

    // If the period is below 2, fade in (alpha <= 0 is fully visible)
    // else fade out.
    this.alpha += this.period >= 2 ? 2 * dt : -dt;

    // Timer for when the next screen needs to start.
    this.period += dt;
    if (this.period >= 3) this.onDone();
  }
}

module.exports = LogoScreen;